added marking
authorChristian Urban <christian.urban@kcl.ac.uk>
Mon, 18 Jan 2021 22:12:39 +0000
changeset 386 e2170c91a9f2
parent 385 44383203970f
child 387 6282b88511d8
added marking
misc/compare
pre_marking3/mk
pre_marking3/postfix.scala
pre_marking3/postfix2.scala
pre_marking3/postfix_test.sh
pre_marking3/postfix_test1.scala
pre_marking3/postfix_test2.scala
pre_marking3/postfix_test3.scala
pre_marking3/postfix_test4.scala
pre_marking4/knight1_test.sh
pre_marking4/knight1_test1.scala
pre_marking4/knight1_test2.scala
pre_marking4/knight1_test3a.scala
pre_marking4/knight1_test3b.scala
pre_marking4/knight1_test3c.scala
--- a/misc/compare	Fri Jan 15 02:47:51 2021 +0000
+++ b/misc/compare	Mon Jan 18 22:12:39 2021 +0000
@@ -3,15 +3,19 @@
 
 trap "exit" INT
 
-files=${1:-assignment20187-*}
+files=${1:-*/pre3}
 
 for sd in $files; do
   cd $sd
-  #cp output output1
-  cmp -s output output1 > /dev/null
+  #echo $sd
+  echo `tail -n 1 output` > x1
+  echo `tail -n 1 output-2` > x2
+  cmp -s x1 x2 > /dev/null
   if [ $? -eq 1 ]; then
       echo $sd + "is different"
   fi
+  rm x1 x2
+  cd ..
   cd ..
 done
 
--- a/pre_marking3/mk	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/mk	Mon Jan 18 22:12:39 2021 +0000
@@ -20,7 +20,7 @@
   rm postfix_test1.scala
   rm postfix_test2.scala
   rm postfix_test3.scala
-  rm postfix_test3.scala
+  rm postfix_test4.scala
   cd ..
   cd ..
 done
--- a/pre_marking3/postfix.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -2,7 +2,7 @@
 // by Edsger Dijkstra
 // ========================
 
-object CW9a {
+object CW8a {
 
 type Toks = List[String]
 
--- a/pre_marking3/postfix2.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix2.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -2,7 +2,7 @@
 // including Associativity for Operators 
 // =====================================
 
-object CW9b { 
+object CW8b { 
 
 // type of tokens
 type Toks = List[String]
--- a/pre_marking3/postfix_test.sh	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix_test.sh	Mon Jan 18 22:12:39 2021 +0000
@@ -30,7 +30,7 @@
 # functional tests
 
 function scala_assert {
-  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -nc -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)
 }
 
 # purity test
@@ -58,7 +58,7 @@
 #
 if  [ $tsts -eq 0 ]
   then   
-  echo -e "postfix.scala does not contain VARS, RETURNS etc??" | tee -a $out
+  echo -e "postfix.scala does not contain VARS, RETURNS etc?" | tee -a $out
 
   if (scala_vars postfix.scala)
   then
@@ -69,7 +69,7 @@
     tsts=$(( 0 )) 
   fi
 else
-   tsts=$(( 1 ))  
+  tsts=$(( 1 ))  
 fi  
 
 
@@ -185,7 +185,7 @@
   echo -e " compute(syard(split(\"( 4 ^ 3 ) ^ 2\"))) == 4096" | tee -a $out
   echo -e " compute(syard(split(\"( 3 + 1 ) ^ 2 ^ 3\"))) == 65536" | tee -a $out
   
-  if (scala_assert "postfix2.scala" "postfix_test10.scala")
+  if (scala_assert "postfix2.scala" "postfix_test4.scala")
   then
       echo -e "  --> success" | tee -a $out
       marks=$(( marks + 0.5 ))
--- a/pre_marking3/postfix_test1.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix_test1.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -1,4 +1,4 @@
-import CW9a._
+import CW8a._
 
 
 assert(syard(split("3 + 4 * ( 2 - 1 )")) == List("3", "4", "2", "1", "-", "*", "+"))
--- a/pre_marking3/postfix_test2.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix_test2.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -1,4 +1,4 @@
-import CW9a._
+import CW8a._
 
 assert(compute(syard(split("3 + 4 * ( 2 - 1 )"))) == 7)
 assert(compute(syard(split("10 + 12 * 33"))) == 406)
--- a/pre_marking3/postfix_test3.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix_test3.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -1,4 +1,4 @@
-import CW9b._
+import CW8b._
 
 
 assert(syard(split("3 + 4 * ( 2 - 1 )")) == List("3", "4", "2", "1", "-", "*", "+"))
--- a/pre_marking3/postfix_test4.scala	Fri Jan 15 02:47:51 2021 +0000
+++ b/pre_marking3/postfix_test4.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -1,4 +1,4 @@
-import CW9b._
+import CW8b._
 
 
 assert(compute(syard(split("3 + 4 * ( 2 - 1 )"))) == 7)
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test.sh	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,218 @@
+#!/bin/zsh
+
+# to make the script fail safely
+set -euo pipefail
+
+out=${1:-output}
+
+echo "" > $out
+
+echo `date` >> $out
+echo -e "Below is the feedback and provisional marks for your submission" >> $out
+echo -e "of the Preliminary Part of Part 4 (Scala).  Please note all marks are provisional until" >> $out
+echo -e "ratified by the assessment board -- this is not an official" >> $out
+echo -e "results transcript." >> $out
+echo -e "" >> $out
+
+echo -e "Below is the feedback for your submission knight1.scala" >> $out
+echo -e "" >> $out
+
+
+
+# marks for CW8 part 1
+marks=$(( 0.0 ))
+
+
+function scala_compile {
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala "$1") # 2>> $out 1>> $out) 
+}
+
+# functional tests
+
+function scala_compile {
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -Xprint:parser "$1" 2> c$out 1> c$out)
+}
+
+# functional tests
+
+function scala_assert {
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)
+}
+
+function scala_assert_slow {
+  (ulimit -t 120; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)  
+}
+
+function scala_assert_thirty {
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)  
+}
+
+function scala_assert_quick {
+  (ulimit -t 30; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)    
+}
+
+function scala_assert_long {
+  (ulimit -t 60; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null)    
+}
+
+function scala_assert_elong {
+  (ulimit -t 90; JAVA_OPTS="-Xmx1g" scala -i "$1" -- "$2" -e "" 2> /dev/null 1> /dev/null) 
+}
+
+# purity test
+
+
+function scala_vars {
+   (egrep '\bvar\b|\breturn\b|\.par\.|\.par |ListBuffer|AtomicInteger|mutable|util.control|new Array' c$out 2> /dev/null 1> /dev/null)
+}
+
+
+# compilation test
+
+echo -e "knight1.scala runs?" | tee -a $out
+
+if (scala_compile knight1.scala)
+then
+    echo -e "  --> success " | tee -a $out
+    tsts=$(( 0 ))
+else
+    echo -e "  --> SCALA DID NOT RUN KNIGHT1.SCALA\n" | tee -a $out
+    tsts=$(( 1 )) 
+fi
+
+
+# knights1: purity test
+if  [ $tsts -eq 0 ]
+  then   
+  echo -e "knight1.scala does not contain VARS, RETURNS etc?" | tee -a $out
+
+  if (scala_vars knight1.scala)
+  then
+     echo -e "  --> FAIL\n" | tee -a $out
+     tsts=$(( 1 ))
+  else
+     echo -e "  --> success" | tee -a $out
+     tsts=$(( 0 )) 
+  fi
+else
+  tsts=$(( 1 ))  
+fi
+
+
+
+### knight1 test
+
+if [ $tsts -eq 0 ]
+then
+    echo " is_legal(8, Nil, (3, 4)) == true " | tee -a $out
+    echo " is_legal(8, List((4, 1), (1, 0)), (4, 1)) == false " | tee -a $out
+    echo " is_legal(2, Nil, (0, 0)) == true" | tee -a $out                          
+
+    if (scala_assert "knight1.scala" "knight1_test1.scala")
+    then
+        echo -e "  --> success" | tee -a $out
+	marks=$(( marks + 1.0 ))
+    else
+        echo -e "  --> \n ONE TEST FAILED\n"| tee -a $out
+    fi
+fi
+
+### knight2 test
+
+if [ $tsts -eq 0 ]
+then
+  echo " legal_moves(8, Nil, (2,2)) == List((3,4), (4,3), (4,1), (3,0), (1,0), (0,1), (0,3), (1,4))" | tee -a $out
+  echo " legal_moves(8, Nil, (7,7)) == List((6,5), (5,6))" | tee -a $out
+  echo " legal_moves(8, List((4,1), (1,0)), (2,2)) == List((3,4), (4,3), (3,0), (0,1), (0,3), (1,4))" | tee -a $out
+  echo " legal_moves(8, Nil, (0,1)) == List((1,3), (2,2), (2,0))" | tee -a $out
+  echo " legal_moves(8, List((6,6)), (7,7)) == List((6,5), (5,6))" | tee -a $out
+  echo " legal_moves(1, Nil, (0,0)) == Nil" | tee -a $out
+  echo " legal_moves(2, Nil, (0,0)) == Nil" | tee -a $out
+  echo " legal_moves(3, Nil, (0,0)) == List((1,2), (2,1))" | tee -a $out
+  
+  if (scala_assert "knight1.scala" "knight1_test2.scala")
+  then
+     echo -e "  --> success\n" | tee -a $out
+     marks=$(( marks + 1 ))
+  else
+     echo -e "  --> ONE TEST FAILED\n" | tee -a $out
+  fi
+fi
+
+
+### knight3 test
+
+if [ $tsts -eq 0 ]
+then
+  echo " count_tours from every position on the board 1 - 4" | tee -a $out
+  echo " dim = 1: 1" | tee -a $out
+  echo "       2: 0,0,0,0" | tee -a $out
+  echo "       3: 0,0,0,0,0,0,0,0,0" | tee -a $out
+  echo "       4: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0" | tee -a $out
+  START=$(date +%s)
+  
+  if (scala_assert "knight1.scala" "knight1_test3a.scala") 
+  then
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo " It took $DIFF seconds" | tee -a $out  
+     echo -e "  --> success\n" | tee -a $out
+     marks=$(( marks + 0.5 ))
+  else
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo " It took $DIFF seconds" | tee -a $out 
+     echo -e "  --> ONE TEST FAILED\n" | tee -a $out
+  fi
+fi
+
+
+if [ $tsts -eq 0 ]
+then
+  echo " count_tours from every position on the board of dim 5" | tee -a $out
+  echo " dim = 5: 304,0,56,0,304,0,56,0,56,0,56,0,64,0,56,0,56,0,56,0,304,0,56,0,304" | tee -a $out
+  START=$(date +%s)
+  
+  if (scala_assert "knight1.scala" "knight1_test3b.scala") 
+  then
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo " It took $DIFF seconds" | tee -a $out  
+     echo -e "  --> success\n" | tee -a $out
+     marks=$(( marks + 0.5 ))
+  else
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo " It took $DIFF seconds" | tee -a $out 
+     echo -e "  --> ONE TEST FAILED\n" | tee -a $out
+  fi
+fi
+
+
+if [ $tsts -eq 0 ]
+then
+  echo " enum_tours(5, List((0,2)) ) => 56 tours? and all correct?" | tee -a $out
+  echo " enum_tours(5, List((0,0)) ) => 304 tours? and all correct?" | tee -a $out
+  START=$(date +%s)
+  
+  if (scala_assert "knight1.scala" "knight1_test3c.scala") 
+  then
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo "  It took $DIFF seconds" | tee -a $out 
+     echo -e "  --> success\n" | tee -a $out
+     marks=$(( marks + 1.0 ))
+  else
+     END=$(date +%s)
+     DIFF=$(( $END - $START ))
+     echo " It took $DIFF seconds" | tee -a $out 
+     echo -e "  --> \n ONE TEST FAILED\n" | tee -a $out
+  fi
+fi
+
+
+## final marks
+echo -e "Overall mark for the Preliminary Part 4 (Scala)" | tee -a $out
+printf " %0.1f\n" $marks | tee -a $out
+
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test1.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,9 @@
+import CW9a._
+
+assert(is_legal(8, Nil, (3, 4)) == true)
+assert(is_legal(8, List((4, 1), (1, 0)), (4, 1)) == false)
+assert(is_legal(2, Nil, (0, 0)) == true)
+
+
+
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test2.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,13 @@
+import CW9a._
+
+assert(legal_moves(8, Nil, (2,2)) == 
+             List((3,4), (4,3), (4,1), (3,0), (1,0), (0,1), (0,3), (1,4)))
+assert(legal_moves(8, Nil, (7,7)) == List((6,5), (5,6)))
+assert(legal_moves(8, List((4,1), (1,0)), (2,2)) == 
+       List((3,4), (4,3), (3,0), (0,1), (0,3), (1,4)))
+assert(legal_moves(8, Nil, (0,1)) == List((1,3), (2,2), (2,0)))
+assert(legal_moves(8, List((6,6)), (7,7)) == List((6,5), (5,6)))
+assert(legal_moves(1, Nil, (0,0)) == Nil)
+assert(legal_moves(2, Nil, (0,0)) == Nil)
+assert(legal_moves(3, Nil, (0,0)) == List((1,2), (2,1)))
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test3a.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,14 @@
+import CW9a._
+
+def count_all_tours_urban(dim: Int) = {
+  for (i <- (0 until dim).toList; 
+       j <- (0 until dim).toList) yield count_tours(dim, List((i, j)))
+}
+
+
+assert(count_all_tours_urban(1) == List(1))
+assert(count_all_tours_urban(2) == List(0, 0, 0, 0))
+assert(count_all_tours_urban(3) == List(0, 0, 0, 0, 0, 0, 0, 0, 0))
+assert(count_all_tours_urban(4) == List(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0))
+
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test3b.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,12 @@
+import CW9a._
+//type Pos = (Int, Int)    // a position on a chessboard 
+//type Path = List[Pos]    // a path...a list of positions
+
+def count_all_tours_urban(dim: Int) = {
+  for (i <- (0 until dim).toList; 
+       j <- (0 until dim).toList) yield count_tours(dim, List((i, j)))
+}
+
+
+assert(count_all_tours_urban(5) == List(304, 0, 56, 0, 304, 0, 56, 0, 56, 0, 56, 0, 64, 0, 56, 0, 56, 0, 56, 0, 304, 0, 56, 0, 304))
+
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/pre_marking4/knight1_test3c.scala	Mon Jan 18 22:12:39 2021 +0000
@@ -0,0 +1,33 @@
+import CW9a._
+
+//type Pos = (Int, Int)    // a position on a chessboard 
+//type Path = List[Pos]    // a path...a list of positions
+
+def add_pair_urban(x: Pos)(y: Pos): Pos = 
+  (x._1 + y._1, x._2 + y._2)
+
+def is_legal_urban(dim: Int, path: Path)(x: Pos): Boolean = 
+  0 <= x._1 && 0 <= x._2 && x._1 < dim && x._2 < dim && !path.contains(x)
+
+def moves_urban(x: Pos): List[Pos] = 
+  List(( 1,  2),( 2,  1),( 2, -1),( 1, -2),
+       (-1, -2),(-2, -1),(-2,  1),(-1,  2)).map(add_pair_urban(x))
+
+def legal_moves_urban(dim: Int, path: Path, x: Pos): List[Pos] = 
+  moves_urban(x).filter(is_legal_urban(dim, path))
+
+def correct_urban(dim: Int)(p: Path): Boolean = p match {
+  case Nil => true
+  case x::Nil => true
+  case x::y::p => if (legal_moves_urban(dim, p, y).contains(x)) correct_urban(dim)(y::p) else false
+}
+
+
+val ts00_urban = enum_tours(5, List((0, 0)))
+assert(ts00_urban.map(correct_urban(5)).forall(_ == true) == true)
+assert(ts00_urban.length == 304)  
+
+
+val ts_urban = enum_tours(5, List((0, 2)))
+assert(ts_urban.map(correct_urban(5)).forall(_ == true) == true)
+assert(ts_urban.length == 56)